/* spectrum1.c vibfunc.h graph2d.h                              2005.9.5  */
/*@g`̃XyNg͂Ɣg`                                    */
/*Eg`XyNg͂CLXyNgɂg`s        */
/*EȂXyNgɂg`g`cނƂ              */
/*E͂g`̓j[IԂC̃t@CI          */
/*Ej[ɂ(1)`g,(2)Opg,(3)g,(4)AMϒg,(5)FMϒg   */
/*  (6)Ώ̋`g                                                 */
/*Et@Cfile="perioddata"ƂClf[^ׂ݂̂         */
/*Eg`CXyNgCLXyNgɂ鍇g`}            */
/*EFourier(fn,n,m,Fc,Fs):fn[0-n], Fc,Fs[0-m], n<1001:even number, m<=n/2  */
/*Eyy=ift(Fc,Fs,M,yy,n,k) : Fc,Fs[0-M], yy[k], total data n              */
/* fn[] : periodical wave data                                            */
/* Fc[],Fs[] : spectrum cos, sin                                          */
/**************************************************************************/


#include    <stdio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/****************************************************************************/
//       mainŒ`Cvibfunc.hŎg֐                                  //
/****************************************************************************/
double f(int i, double t, double y[]) {return (0);}
/****************************************************************************/

/***************************************************************************/
//       vibfunc.hŒ`CmainŎg֐                                 //
/*************************************************** 2005.9.05 *************/
// vibfunc.h   UV~[^̂߂̊֐Q                              //
//  (1) rkg(t,dt,z0,z4,n) : Runge-Kutta-Gill@ɂ̉         //
//  (2) det=imatrx(n, *a, nmax) : ts)ƍs񎮂̒l                        //
//  (3) Fourier(f[], n, m, Fc[], Fs[]) : Fourierϊ(FourierWJj     //
//  (4) InvFourier(Fc[], Fs[], m, n, f[]) : Fouriertϊ                  //
//  (6) drawfigure(r0[], n, a[]) : nRxUȔuԐ}                 //
//  (7) drawcurve(r0[], wx, wy, n, m, *a, mmax) : n{̐UȐ`        //
//  (8) drawcurve1(r0[], wx, wy, m, *a, mmax)   : (X,Y)ʏ̔CӋȐ`//
//  (9) drawbargraph(r0[], wx, wy, m, a[]) : _Ot`                  //
//  (10) drawfreqcurve()
/***************************************************************************/




/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          601
#define   PAI           3.14159265358979
#define   RAD           1.745329252e-2

static double r0[2], rc[2], rf[2], rh[2], rh1[2], rg[2];    //e}̌_
static double r1[2], r2[2];
static double fn[MMAX], fsyn[MMAX];    //g`Cg`
static double Fc[MMAX], Fs[MMAX], F[MMAX];     //XyNg(cos,sin)CXyNg̐U
static double yseries[10][MMAX];     //Ȑ`̕f[^
static int    nmax, mmax;            //FourierWJf[^Eg̐
static int    msyn, msynn[10];       //g`̃XyNgẺߋ̃XyNgL
static int    gcnt;                  //g`s̉
static double wt, wy, wyn[10];       //g``̉݁Ec{
static int    mf=250;                //Pg`̉ݐCȐ
static int    nt;                    //g``̉ݐ(=1/wt)
static double wf=0.02, wa;           //PgȐ`̉݁Ec{
static int    m, n;
static double yy;                    //fileǂݍރf[^
static double th1;                   //Ώ̋`g̕(deg)
static int    MotionSign;
unsigned char h, KEY, KEY1;
FILE*fp;   char fname[32];
void   dialogue();
//double xedge=0.99;
/**************************************************************************/
//       g`e                                                     //
// (1)  `g
// (2)  Opg
// (3)  g
// (4)  AMϒg
// (5)  FMϒg
// (6)  Ώ̋`g
/**************************************************************************/
/******** `g *****************************************/
void kukei(int n)
  {
	static int i;
	fn[0]=fn[n]=0;
    for(i=1;i<n;i++)  
	{ fn[i]=1; if(i==n/2) fn[i]=0; if(i>n/2) fn[i]=-1; }
  }
/******** Opg *************************************************/
void sankaku(int n)
  {
	static int i;
	fn[0]=fn[n]=0;
    for(i=1;i<n;i++)  
	{ fn[i]=2.0*i/(double)n; if(i>n/2) fn[i]=2.0*(n-i)/(double)n; }
  }
/********* g *****************************************/
void kyosi(int n)
  {
	static int i;
	fn[0]=fn[n]=1;
    for(i=1;i<n;i++)  
	{ fn[i]=2.0*i/(double)n; }
  }
/********* `lϒgFgfc=10*Mgfs **************************/
void AM(int n)
  {
	static int i;
	fn[0]=fn[n]=1;
    for(i=1;i<n;i++)  
      {fn[i]=(1+0.5*sin(2*PAI*i/(double)n))*cos(2*PAI*10*i/(double)n);}
  }
/********* elϒgFgfc=10*Mgfs ***********************/
void FM(int n) 
  {
	static int i;
	static double p;
    fn[0]=fn[n]=0;
    for(i=1;i<n;i++)  
      {p=2*PAI*sin(2*PAI*i/(double)n);
       fn[i]=cos((10*2*PAI+p)*i/(double)n);}
  }
/********** Ώ̋`g *****************************************/
void asymrect(double th1, int n)
  {
	static int i, k;
	fn[0]=fn[n]=0;
    for(i=1;i<n;i++)
      {k=n*th1/360.0;
       if(i<=k) fn[i]=1; else fn[i]=-1;}
  }
/**********@g`e@I ******************************************/




/************************************************************************************/
int main(int argc, char *argv[])
{
//	static int i, m, n;
//	static double zeta0[]={0.0, 0.05, 0.1, 0.2, 0.5, 0.7071, 1.0, 2.0, 5.0};

	KEY = 'm';
	dialogue();

	DrawGL(&argc, argv);
}
/********* main() end ***********************************************************/

/*************** dialogue() *****************************************************/
void dialogue(void)
{
	static int i, j, k;

	if(KEY=='m')  goto d1;      //VȎg`I
	if(KEY=='n')  goto d2;      //g`̃XyNgύX
d1:
    printf("\ng`̃XyNg͂ƗLXyNgɂg`");
	printf("\ng`ŗpXyNgȂƍČg`cނƂ\n");
	printf("\n(1) g`̑I");
	printf("\n(2) g`̂߂̃XyNgݒ\n");
	printf("\n(1) g`j[C܂͎̃t@CI");
	printf("\n    t@Cfile=""perioddata1,2,...""Ƃ\n");
    printf("\n    `g:2  Opg:3  g:4  `lϒg:5  elϒg:6 ");
    printf("\n    Ώ̋`g:7  t@C:8  ");
    h=getch(); if(h=='8') goto p2;

   //----------- j[g`Iԁfn[] ------------------------//
   nmax = 500;
   nt = nmax;
   mmax = nmax/2;
   if(h=='2') kukei( nmax );
   if(h=='3') sankaku( nmax );
   if(h=='4') kyosi( nmax );
   if(h=='5') { printf("\ng10*Mg"); AM( nmax ); }
   if(h=='6') { printf("\ng10*Mg"); FM( nmax ); }
   if(h=='7') { printf("\nΏ̋`g (0-1)(deg)  1(<360)=");   scanf("%lf",&th1);
                asymrect( th1, nmax );
              }
   goto p3;
p2:
	//-------- file="perioddata"f[^ǂݍ ---------------//
	if(h=='8')
	{
    printf("\n\nfilename=(perioddata1,2,...)"); scanf("%s",fname);
    fp=fopen(fname,"rt");
    nmax=0;
    while(fscanf(fp,"%lf\n",&yy)==1) { fn[nmax]=yy; nmax++;if(nmax>400) break; }
    fclose(fp);
	}
	mmax = nmax/2;
    printf("f[^nmax=%d\n",nmax);
	if(nmax>MMAX)  { printf("\nf[^n=%d>MAX=%d. n=%dőł؂",nmax,MMAX,MMAX); nmax = MMAX; } 

p3:
   //---------- g`̃XyNg ------------------------------------//
   FourierS(fn, nmax, mmax, Fc, Fs);
   for(i=0;i<=mmax;i++) F[i] = sqrt( Fc[i]*Fc[i] + Fs[i]*Fs[i] );
   //---------- g`yseries[0][] ---------//
   gcnt = 0;     //g`̏
   for(i=0;i<=nmax;i++)  yseries[0][i] = fn[i];

   //---------- g`ŗpXyNg̐msyn -------------------//
d2:
   printf("\n\n f[^nmax=%d    g`̂߂̗pXyNgw",nmax);
   printf("\n   pXyNg msyn(<=%d)=",nmax/2); scanf("%d",&msyn);
   nt = nmax;
   msynn[gcnt] = msyn;

   //---------- g`(myn̃XyNgCnmax̃f[^fsyn[]) --------//
   InvFourierS(fsyn, nmax, msyn, Fc, Fs);
   //---------- g`yseries[gcnt][] ----------//
   for(i=0;i<=nmax;i++)  yseries[gcnt][i] = fsyn[i];
   gcnt++;

    //--------- `eύX -------------------------//
	printf("\n'm'L[ŁFg`I");
	printf("\n'n'L[ŁFg`ɎgXyNgύX");
	printf("\n'X' or 'x'L[ŁFXyNg̉gk");
	printf("\n'Y' or 'y'L[ŁFXyNg̏cgk");
	printf("\n'T' or 't'L[ŁFg`̎Ԏgk");
	printf("\nESCL[ŁFI\n");

   //------- `̌_ʒuE݁Eg嗦̏ݒ -----------------------//
	//------ g` --------------------//
	wt = 0.002; wy = 0.5;
	if(h=='5' || h=='6')  wy = 0.25;
	for(i=0;i<10;i++) wyn[i] = wy;
	r0[0] = -0.99;  r0[1] = 0;
	rc[0] = r0[0];  rc[1] = r0[1]-0.3;
	//------ XyNg(50Ԗ=1/wf=1.0ɕ`) ----//
	wf = 0.01;  mf = 250;   wa = 0.5;
	rf[0] = rc[0] + 1.0;  rf[1] = rc[1];
	//------ g` -----------------------------//
	rh[0] = rh1[0] = rc[0];    rh[1] = rh1[1] = rc[1];
}
/************ dialogue() end ***********************************************/


/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("g`́̕E  m:g`ICn:pXyNgύX");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int i;

	usrSetting();

	//--- g``Fr0[]_CwtԎCwy[]c{Cn{ȐCm̓_CUa[i][k]
    drawcharacter(-0.95, 0.90, H18, "blue : original wave x(t)");
    drawcharacter(-0.95, 0.85, H18, "red  : composed wave by m spectrum x(t)");
	drawcharacter(-0.95, 0.80, H18, "1grid = (0.1sec, 0.2m), t=0(0.002)1(sec)");
	//usrDrawAxis2d( r0, 0.0 );
    usrGrating( r0, 0.0, 10, 0.1, 0.1 );
	drawcurve1( rc, wt, wy, nt, fn, blue );
	//----- g`g`֏d˕`Eւ炵ĕ` ----------//
//	drawcurve1( rc, wt, wy, nt, fsyn, red );
	rh1[0] = rc[0];   rh1[1] = rc[1]+0.2;
	if(h=='5' || h=='6')   rh1[1] = rc[1]+0.5;
	drawcurve1( rh1, wt, wy, nt, fn,  blue );
	drawcurve1( rh1, wt, wy, nt, fsyn, red );
	//----- g`g`֏d˕` ----------------------------//
//void drawcurven( double r0[], double wx, double wy[], int n, int m, double *a, int mmax )
	drawcurven(rc, wt, wyn, gcnt, nt, yseries, MMAX);


	//------XyNg`Frf[]_Cwfg݁Cwac{-----------------------//
    drawcharacter(0.01, 0.90, H18, "red bargraph : spectrum abs(X(jom))");
	drawcharacter(0.01, 0.85, H18, "blue point : spectrum number m");
	drawcharacter(0.25, 0.80, H18, "for wave composition");
	drawcharacter(0.01, 0.75, H18, "1grid = (10Hz, 0.2m), f=0(1)250(Hz)");
		r1[0] = rf[0];        r1[1] = rf[1];
		r2[0] = rf[0]+1.0;    r2[1] = rf[1];
        usrDrawLine2d(r1, r2, red);            //
		for(i=0;i<gcnt;i++)
		{   r1[0] = rf[0]+msynn[i]*wf;  r1[1] = rf[1];
		    usrDrawSolidCircle2d(r1, 0.008, blue);  //g`ɎgXyNg
		}
		r1[0] = rf[0]+150*wf;        r1[1] = rf[1]+2*wa;
        usrGrating( r1, 0.0, 10, 15*wf, 0.2*wa );
		drawbargraph(rf, wf,  wa,  mmax, F);

	usrFlushAndSwap();
}
/*********** usrdisplay() end ***********************************************/

/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	KEY1 = KEY;
	KEY = key;

	if(key=='m' || key=='n')              //g`ICg`̃XyNgύX
	{
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='x' || key=='X')                          //XyNggk
	{
		if(key=='X')  wf = wf/0.9;
		if(key=='x')  wf = 0.9*wf;
		KEY = KEY1;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='y' || key=='Y')                          //XyNgcgk
	{
		if(key=='Y')  wa = wa/0.9;
		if(key=='y')  wa = 0.9*wa;
		KEY = KEY1;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='t' || key=='T')                          //g`Ԏgk
	{
		if(key=='T')  wt = wt/0.9;
		if(key=='t')  wt = 0.9*wt;
		nt = 1/wt;   if(nt>nmax) nt = nmax;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='\033')   exit(0);

end:;
}

void motion_function(void){ }
